<?php
//-------------------------------------------------------------------
// Define your id.
//-------------------------------------------------------------------
// user id information
define("ACCESS_KEY_ID"     , 'Your Yahoo! Web API id.                                         ');
// yid = Yahoo! affiliate id , vc = ValueCommerce id
define("AFFILIATE_COM"     , 'yid/vc'                                                          );
define("AFFILIATE_TAG"     , 'Your Yahoo! or ValueCommerce affiliate id.'                      );

// access url(Jpanan)
define("ACCESS_URL"        , 'http://shopping.yahooapis.jp/ShoppingWebService/V1/');
//-------------------------------------------------------------------
//http://shopping.yahooapis.jp/ShoppingWebService/V1/itemSearch?    -- item search
//http://shopping.yahooapis.jp/ShoppingWebService/V1/categorySearch? -- category search


//-------------------------------------------------------------------
// this function is encode with RFC3986 format.
//-------------------------------------------------------------------
function urlencode_RFC3986($str)
{
    return str_replace('%7E', '~', rawurlencode($str));
}


//-------------------------------------------------------------------
// Main routine.
//-------------------------------------------------------------------

$base_param = 'appid='.ACCESS_KEY_ID;

$params = array();

$params['affiliate_type'] = AFFILIATE_COM;
$params['affiliate_id']   = AFFILIATE_TAG;

$params['sort']           = '-sold';  //	price/name/score/sold/affiliate/review_count (+/-)
$params['type']           = 'all';	//	all/any
//$params['category_id']  = 10002;   // category (book)
$params['category_id']    = 2502;   // category (pc/software)
$params['query']          = 'Windows 7 Microsoft';        // search key ( UTF-8 )

$params['offset']         = 0;	//	[1-20]

// sort $param by asc.
ksort($params);

// create canonical string.
$canonical_string = $base_param;
foreach ($params as $k => $v) {
    $canonical_string .= '&'.urlencode_RFC3986($k).'='.urlencode_RFC3986($v);
}

// create URL strings.
$url = ACCESS_URL.'itemSearch?'.$canonical_string;	//	service = itemSearch 

// request to yahoo !!
$response = file_get_contents($url);

// response to strings.
$parsed_xml = null;
if(isset($response)){
	$parsed_xml = simplexml_load_string($response);
}

$err_count=0;

// print out of response.
if( $response && 
    isset($parsed_xml) && 
    isset($parsed_xml->attributes()->totalResultsReturned)  ){

	// total results num.
	$total_results = $parsed_xml->attributes()->totalResultsAvailable;
	// total results pages.
	$total_pages = floor(($parsed_xml->attributes()->totalResultsAvailable + 19)/20);
	
	print("All Result Count:".$total_results."  | Pages :".$total_pages );

	print("<table>");
	foreach($parsed_xml->Result->Hit as $current){
		$nerr=0;
		
		print("<tr><td><font size='-1'>");
		
		print('<a href="'.$current->Url.'"><img src="'.$current->Image->Small.'" border=0></a><br >');
		print('<a href="'.$current->Url.'">'.$current->Name.'</a><br />');
	//	print('JAN CODE : '.$current->JanCode.'<br />');
		
		print($current->Price->attributes()->currency);
		if($current->PriceLabel->attributes()->taxIncluded){
			print( " TAX (INCLUDE) : ");
		} else {
			print( " TAX (Not INCLUDE) : ");
		}
		if(isset($current->PriceLabel->SalePrice) && $current->PriceLabel->SalePrice>0){
			print('<br />');
			if(isset($current->PriceLabel->FixedPrice) && $current->PriceLabel->FixedPrice>0){
				print($current->PriceLabel->FixedPrice.'<br />');
			} else if( (int)$current->PriceLabel->SalePrice != (int)$current->Price ){
				print($current->Price.'<br />');
			}
			print('<font color=red>Sale : '.$current->PriceLabel->SalePrice.'</font><br />');
		} else {
			print($current->Price.'<br />');
		}
		
		if(isset($current->Review) && isset($current->Review->Rate) && $current->Review->Count>0){
			print('Rate:<a href="'.$current->Review->Url.'">');
			print($current->Review->Rate.'('. $current->Review->Count .')'.'<br />');
			print('</a><hr />');
		}
		print("</td></tr>");
	}
	print("</table>");
}
?>
